local L = AceLibrary("AceLocale-2.2"):new("lugMD")
local dewdrop = AceLibrary("Dewdrop-2.0")
lugMD = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0", "CandyBar-2.0", "FuBarPlugin-2.0")
lugMD.hasIcon = true
lmd = lugMD
local tabl
local cmdtable = {
	type="group",
	args = {
		bars = {
			type = "group",
			name = L["Bars"],
			desc = L["Bar options"],
			args = {
				
				showBuffs = {
					type = "toggle",
					name = L["Show buffs"],
				    desc = L["Toggle the buff duration timers."],
					get = "IsShowBuffs",
		            set = "ToggleShowBuffs",
					order = 1,
				},
				showCds = {
					type = "toggle",
					name = L["Show cooldowns"],
				    desc = L["Toggle the cooldown duration timers."],
					get = "IsShowCds",
		            set = "ToggleShowCds",
					order =2,
				},
				scaleBuffs = {
		                type = "range",
		                name = L["Scale buffs"],
						desc = L["Scale the buff timers.\n   |cffBF1824 Requires interface reload. |r"],
		                min= .1,
		                max = 3,               
		                get = "GetBuffScale",
		                set = "SetBuffScale",
						order = 3,
		        },
				scaleCds = {
		                type = "range",
		                name = L["Scale cooldowns"],
						desc = L["Scale the cooldown timers.\n   |cffBF1824 Requires interface reload. |r"],
		                min= .1,
		                max = 3,                
		                get = "GetCdScale",
		                set = "SetCDScale",
						order = 4,
		        },
				growup = {
					type = "toggle",
					name = L["Growup"],
				    desc = L["Toggle the timers growth.\n   |cffBF1824 Requires interface reload. |r"],
					get = "IsGrowup",
		            set = "ToggleGrowup",
				},
				displayInRaidOnly  = {
				type = "toggle",
				name = L["Display only in raid"],
			    desc = L["Display bars only when part of a raid."],
				get = "IsInRaidOnly",
	            set = "ToggleInRaidOnly",
				},
				
			},
			order = 1
		},
		castAnn = {
			type = "group",
			name = L["Cast Announcement"],
			desc =  L["Cast Announcement options"],
			args = {
				raidAnnounce = {
					type = "toggle",
					name = L["Raid announce"],
				    desc = L["Toggle announcement to raid chat e.g --Misdirection cast on target--"],
					get = "IsRaidAnnounce",
		            set = "ToggleRaidAnnounce",
					order = 1,	
				},
				partyAnnounce = {
					type = "toggle",
					name = L["Party announce"],
				    desc = L["Toggle announcement to party chat e.g --Misdirection cast on target--"],
					get = "IsPartyAnnounce",
		            set = "TogglePartyAnnounce",
					order = 2,	
				},
				castChannelAnnounce = {
					type = "text",
					name = L["Channel announce"],
					usage = "<number>",
				    desc = L["Set announcement to a specified channel number, blank for no announce"],
					get = function() return lmd.db.profile.castChanAnnounce end,
					set = function(name)
						lmd.db.profile.castChanAnnounce = name
					end,
					order = 3,	
				},
				
			},
			order = 2
		},
		tarAnn = {
			type = "group",
			name = L["Target Announcement"],
			desc = L["Target Announcement options"],
			args = {				
				tarRaidAnnounce = {
					type = "toggle",
					name = L["Raid announce"],
				    desc = L["Toggle announcement of targets to raid chat"],
					get = "IsTarRaidAnnounce",
		            set = "ToggleTarRaidAnnounce",
					order =1, 
				},
				tarPartyAnnounce = {
					type = "toggle",
					name = L["Party announce"],
				    desc = L["Toggle announcement of targets to party chat"],
					get = "IsTarPartyAnnounce",
		            set = "ToggleTarPartyAnnounce",
					order = 2,
				},
				tarChannelAnnounce = {
					type = "text",
					name = L["Channel announce"],
					usage = "<number>",
				    desc = L["Set announcement to a specified channel number, blank for no announce"],
					get = function() return lmd.db.profile.tarChanAnnounce end,
					set = function(name)
						lmd.db.profile.tarChanAnnounce = name
					end,
					order = 3,	
				},
			},
			order = 3
		},
		custMsg = {
			type = "group",
			name = L["Customise Announcements"],
			desc = L["Customise Announcements"],
			args = {	
						connector = {
							type = "text",
							name = L["Hunter-Tank connector"],
							usage = "<text>",
						    desc = L["Set connector between tank and hunter, e.g. 'hunter ---> warrior'"],
							get = function() return lmd.db.profile.connector end,
							set = function(name)
								lmd.db.profile.connector = name
							end,
							order = 1,	
						},
						pre = {
							type = "text",
							name = L["Cast msg(Pre)"],
							usage = "<text>",
						    desc = L["Set the message to be announced when MD is cast, e.g. '--Misdirection cast on' "],
							get = function() return lmd.db.profile.pre end,
							set = function(name)
								lmd.db.profile.pre = name
							end,
							order = 2,	
						},
						post = {
							type = "text",
							name = L["Cast msg(Post)"],
							usage = "<text>",
						    desc = L["Set the message to be announced when MD is cast, e.g. '--' "],
							get = function() return lmd.db.profile.post end,
							set = function(name)
								lmd.db.profile.post = name
							end,
							order = 3,	
						},
					},
			order = 4
		},
		showAnchors = {
			type = "toggle",
			name = L["Show anchors"],
			desc = L["Toggle the buff and cooldown anchors."],
			get = "IsShowAnchors",
		    set = "ToggleShowAnchors",	
			order = 4
		},
		
	},
}		
	
lugMDicons = {
	{ name = L["Yellow 4-point Star"],
		number = 1,
		tank = L["None"],
		hunter = L["None"]
	},
	{ name = L["Orange Circle"],
		number = 2,
		tank = L["None"],
		hunter = L["None"]
	},
	 { name = L["Purple Diamond"],
		number = 3,
		tank = L["None"],
		hunter = L["None"]
	},
	{ name = L["Green Triangle"],
		number = 4,
		tank = L["None"],
		hunter = L["None"]
	},
	{  name = L["White Crescent Moon"],
		number = 5,
		tank = L["None"],
		hunter = L["None"]
	},
	{  name = L["Blue Square"],
		number = 6,
		tank = L["None"],
		hunter = L["None"]
	},
	{  name = L["Red 'X' Cross"],
		number = 7,
		tank = L["None"],
		hunter = L["None"]
	},
	{ name = L["White Skull"],
		number = 8,
		tank = L["None"],
		hunter = L["None"]
	}	
}

lugMD:RegisterChatCommand({L["/lmd"], L["/lugmd"], L["/lugMD"]}, cmdtable)

lugMD:RegisterDB("lugMDDB", "lugMDDBPC")
lugMD:RegisterDefaults(
    "profile",
    {
		anchorsVis = true,
		optionsVis = false,
		
        buffVis = true,
		cdVis = true,
		
		growup = false,
			
				
		
		raidAnnounce = true,
		partyAnnounce = false,
		
		tarRaidAnnounce = true,
		tarPartyAnnounce = false,
		tarChanAnnounce = "",
		castChanAnnounce = "",
		connector = " ---> ",
		pre = L["--Misdirection cast on "],
		post = "--",
		
		inRaidOnly = false,
		
		buffScale = 1,
		cdScale = 0.9,	
    }
)

local version = tonumber(string.sub("$Version: 0.5 $", 12, -3))

function lugMD:OnInitialize()
	-- tanktbl = {L["None"]}
	-- huntertbl = {L["None"]}	
	
	roster = AceLibrary("Roster-2.1")
	
	pframe = self:GetFrame()
	
	targetname = " "
	playername = " "
	
	-- Fubar plugin/Minimap icon
	self.hasNoColor = true	
	self:SetIcon("Interface\\Icons\\Ability_Hunter_Misdirection")
	
	self.clickableTooltip = true
	self.hideWithoutStandby = true
	self.hideMenuTitle = true
	self.OnMenuRequest = cmdtable
	-- self.overrideTooltip = true	
	self.blizzardTooltip = true
	self.cannotDetachTooltip = true
	-- self.frame:RegisterForClicks( "RightButton")
	
	
		
	-- Anchor business
	self:anchors()
	
	lugMDBuffAnchorFrameText:SetText(L["Buff anchor"])
	lugMDCooldownAnchorFrameText:SetText(L["Cooldown anchor"])
		
	-- Create the buff timer group
	self:RegisterCandyBarGroup("Misdirection Buff Group")
	self:SetCandyBarGroupGrowth("Misdirection Buff Group", self.db.profile.growup)
	self:SetCandyBarGroupPoint("Misdirection Buff Group", "BOTTOM", "lugMDBuffAnchorFrame", "BOTTOM", 0, -20)
	
	-- Create the cooldown timer group
	self:RegisterCandyBarGroup("Misdirection CD Group")
	self:SetCandyBarGroupGrowth("Misdirection CD Group", self.db.profile.growup)
	self:SetCandyBarGroupPoint("Misdirection CD Group", "BOTTOM", "lugMDCooldownAnchorFrame", "BOTTOM", 0, -20)
	
	-- buff bar			
	self:RegisterCandyBar("Misdirection", 30, nil, "Interface\\Icons\\Ability_Hunter_Misdirection", "green", "yellow", "red")
	self:SetCandyBarScale("Misdirection", self.db.profile.buffScale)	
	
	-- cooldown bar
	self:RegisterCandyBar("Misdirection Cooldown", 120, nil, nil, "black", "gray", "gray", "green")
	self:SetCandyBarBackgroundColor("Misdirection Cooldown", "black", 1)
	self:SetCandyBarTextColor("Misdirection Cooldown", "white", 0.5)
	self:SetCandyBarScale("Misdirection Cooldown", self.db.profile.cdScale)
	
	self:RegisterCandyBarWithGroup("Misdirection", "Misdirection Buff Group")
	self:RegisterCandyBarWithGroup("Misdirection Cooldown", "Misdirection CD Group")	
end

	
function lugMD:OnEnable()	
	self:RegisterEvent("RosterLib_RosterUpdated")	
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_SELF")
	self:RegisterEvent("Send_MDStatus")
	self:RegisterEvent("CHAT_MSG_ADDON")	
end

-- handles raid roster changes
function lugMD:RosterLib_RosterUpdated(tbl)
	-- self:Print("RosterUpdated")
	
	-- reset tables for dropdown menu over iterate over roster table
	
	-- if IsRaidLeader() or IsRaidOfficer() then
			
		
		
		huntertblcolor = {L["None"]}
		
		tanktblcolor = {L["None"]}
		
		for unit in roster:IterateRoster(false) do
		    
			if unit.class == "HUNTER" then		
				table.insert(huntertblcolor, "|cffABD473"..unit.name.."|r")	
				
			end
			if unit.class == "WARRIOR"  then
				table.insert(tanktblcolor,  "|cffC79C6E"..unit.name.."|r")
				
		    end
			if unit.class == "DRUID" then
				table.insert(tanktblcolor,  "|cffFF7D0A"..unit.name.."|r")
				
		    end		
			if unit.class == "PALADIN" then
				table.insert(tanktblcolor,  "|cffF58CBA"..unit.name.."|r")
				
		    end
		end
		
		
		-- generate a targetting table
		tabl = {
			    type = "group",			
				args = {
				star = {
					type = "group",
					name = L["Star"],
					desc = L["Set the tank/hunter"],
					args = {
						hunter = {
						type = "text",
						name = L["Hunter"], 
						desc = L["Set the hunter"],
						get = function() return lugMDicons[1].hunter end,
						set = function(v)							
								lugMDicons[1].hunter = v							
							  end,
						validate = huntertblcolor,
						},
						tanks = {
						type = "text",
						name = L["Tank"], 
						desc = L["Set the tank"],
						get = function() return lugMDicons[1].tank end,
						set = function(v)
								lugMDicons[1].tank = v
								end,
						validate = tanktblcolor,	
					},
					},
					order = 1,
					icon = "Interface\\AddOns\\lugMD\\Icons\\star",
				},
				circle = {
					type = "group",
					name = L["Circle"],
					desc = L["Set the tank/hunter"],
					args = {
						hunter = {
						type = "text",
						name = L["Hunter"], 
						desc = L["Set the hunter"],
						get = function() return lugMDicons[2].hunter end,
						set = function(v)							
								lugMDicons[2].hunter = v							
							  end,
						validate = huntertblcolor,
						},
						tanks = {
						type = "text",
						name = L["Tank"], 
						desc = L["Set the tank"],
						get = function() return lugMDicons[2].tank end,
						set = function(v)
								lugMDicons[2].tank = v
								end,
						validate = tanktblcolor,	
					},
					},
					order = 2,
					icon = "Interface\\AddOns\\lugMD\\Icons\\circle",
				},
				diamond = {
					type = "group",
					name = L["Diamond"],
					desc = L["Set the tank/hunter"],
					args = {
						hunter = {
						type = "text",
						name = L["Hunter"], 
						desc = L["Set the hunter"],
						get = function() return lugMDicons[3].hunter end,
						set = function(v)							
								lugMDicons[3].hunter = v							
							  end,
						validate = huntertblcolor,
						},
						tanks = {
						type = "text",
						name = L["Tank"], 
						desc = L["Set the tank"],
						get = function() return lugMDicons[3].tank end,
						set = function(v)
								lugMDicons[3].tank = v
								end,
						validate = tanktblcolor,	
					},
					},
					order = 3,
					icon = "Interface\\AddOns\\lugMD\\Icons\\diamond",
				},
				triangle = {
					type = "group",
					name = L["Triangle"],
					desc = L["Set the tank/hunter"],
					args = {
						hunter = {
						type = "text",
						name = L["Hunter"], 
						desc = L["Set the hunter"],
						get = function() return lugMDicons[4].hunter end,
						set = function(v)							
								lugMDicons[4].hunter = v							
							  end,
						validate = huntertblcolor,
						},
						tanks = {
						type = "text",
						name = L["Tank"], 
						desc = L["Set the tank"],
						get = function() return lugMDicons[4].tank end,
						set = function(v)
								lugMDicons[4].tank = v
								end,
						validate = tanktblcolor,	
					},
					},
					order = 4,
					icon = "Interface\\AddOns\\lugMD\\Icons\\triangle",
				},
				moon = {
					type = "group",
					name = L["Moon"],
					desc = L["Set the tank/hunter"],
					args = {
						hunter = {
						type = "text",
						name = L["Hunter"], 
						desc = L["Set the hunter"],
						get = function() return lugMDicons[5].hunter end,
						set = function(v)							
								lugMDicons[5].hunter = v							
							  end,
						validate = huntertblcolor,
						},
						tanks = {
						type = "text",
						name = L["Tank"], 
						desc = L["Set the tank"],
						get = function() return lugMDicons[5].tank end,
						set = function(v)
								lugMDicons[5].tank = v
								end,
						validate = tanktblcolor,	
					},
					},
					order = 5,
					icon = "Interface\\AddOns\\lugMD\\Icons\\moon",
				},
				square = {
					type = "group",
					name = L["Square"],
					desc = L["Set the tank/hunter"],
					args = {
						hunter = {
						type = "text",
						name = L["Hunter"], 
						desc = L["Set the hunter"],
						get = function() return lugMDicons[6].hunter end,
						set = function(v)							
								lugMDicons[6].hunter = v							
							  end,
						validate = huntertblcolor,
						},
						tanks = {
						type = "text",
						name = L["Tank"], 
						desc = L["Set the tank"],
						get = function() return lugMDicons[6].tank end,
						set = function(v)
								lugMDicons[6].tank = v
								end,
						validate = tanktblcolor,	
					},
					},
					order = 6,
					icon = "Interface\\AddOns\\lugMD\\Icons\\square",
				},
				cross = {
					type = "group",
					name = L["Cross"],
					desc = L["Set the tank/hunter"],
					args = {
						hunter = {
						type = "text",
						name = L["Hunter"], 
						desc = L["Set the hunter"],
						get = function() return lugMDicons[7].hunter end,
						set = function(v)							
								lugMDicons[7].hunter = v							
							  end,
						validate = huntertblcolor,
						},
						tanks = {
						type = "text",
						name = L["Tank"], 
						desc = L["Set the tank"],
						get = function() return lugMDicons[7].tank end,
						set = function(v)
								lugMDicons[7].tank = v
								end,
						validate = tanktblcolor,	
					},
					},
					order = 7,
					icon = "Interface\\AddOns\\lugMD\\Icons\\cross",
				},
				skull = {
					type = "group",
					name = L["Skull"],
					desc = L["Set the tank/hunter"],				
					args = {
						hunter = {
						type = "text",
						name = L["Hunter"], 
						desc = L["Set the hunter"],
						get = function() return  lugMDicons[8].hunter  end,
						set = function(v)							
								lugMDicons[8].hunter = v					
							  end,
						validate = huntertblcolor,					
						},
						tanks = {
						type = "text",
						name = L["Tank"], 
						desc = L["Set the tank"],
						get = function() return lugMDicons[8].tank end,
						set = function(v)
								lugMDicons[8].tank = v							
								end,
						validate = tanktblcolor,	
					},
					},
					order = 8,
					icon = "Interface\\AddOns\\lugMD\\Icons\\skull",
				},
				
			}
		}
		tabl2 = {
					type = "group",
					name = L["Skull"],
					desc = L["Set the tank/hunter"],				
					args = {
						hunter = {
						type = "text",
						name = L["Hunter"], 
						desc = L["Set the hunter"],
						get = function() return  lugMDicons[8].hunter  end,
						set = function(v)							
								lugMDicons[8].hunter = v					
							  end,
						validate = huntertblcolor,					
						},
						tanks = {
						type = "text",
						name = L["Tank"], 
						desc = L["Set the tank"],
						get = function() return lugMDicons[8].tank end,
						set = function(v)
								lugMDicons[8].tank = v							
								end,
						validate = tanktblcolor,	
					},
					},
					
					icon = "Interface\\AddOns\\lugMD\\Icons\\skull",
				}
		-- table.insert(cmdtable, tabl2)
		-- self.OnMenuRequest = cmdtable
		
		dewdrop:Register(Minimap,'children', 
								function()

								dewdrop:FeedAceOptionsTable(tabl)
								
								end
								)
	-- end
end

function lugMD:UNIT_SPELLCAST_SUCCEEDED()
	sucSpellname = arg2
	
	if (sucSpellname == L["Misdirection"]) then
		-- self.succeeded = true
		-- self:Print("Misdirection", self.succeeded)
		
		self:SetCandyBarText("Misdirection", targetname)
		self:SetCandyBarText("Misdirection Cooldown", L["Your Cooldown"])
		
		self:Send_MDStatus(targetname)
		
		if self.db.profile.buffVis then
			if self.db.profile.inRaidOnly then
				if UnitInRaid("player") then
					self:StartCandyBar("Misdirection")
				end
			else self:StartCandyBar("Misdirection") end		
		end
		
		if self.db.profile.cdVis then
			if self.db.profile.inRaidOnly then
				if UnitInRaid("player") then
					self:StartCandyBar("Misdirection Cooldown")
				end
			else self:StartCandyBar("Misdirection Cooldown") end
		end	
	-- else
		-- self:Print("something else")
		-- self.succeeded = false
	end
end

function lugMD:UNIT_SPELLCAST_SENT()
	-- arg1 = caster, arg2 = spell,  arg3 = rank N/A,  arg4 = target
	-- self:Print(arg1)
	-- self:Print(arg2)
	-- self:Print(arg3)
	-- self:Print(arg4)	
	-- local playername = UnitName("player")
	-- self:Print(self.playername)
	
	playername = UnitName(arg1)	
	spellname = arg2
	targetname = arg4	
	
	-- self:Print("hello")
	-- self:Print(self.db.profile.tarChanAnnounce)
	-- self:Print(self.db.profile.inRaidOnly)
	-- self:Print("sent = ", self.succeeded)
	-- if (spellname == L["Misdirection"]) and not self.succeeded then
		-- self:Print("Failed")
	-- end
	-- if (spellname == L["Misdirection"]) and self.succeeded then
		-- self:Print("Success!")	
		-- self:SetCandyBarText("Misdirection", targetname)
		-- self:SetCandyBarText("Misdirection Cooldown", L["Your Cooldown"])
		
		-- self:Send_MDStatus(targetname)
		
		-- if self.db.profile.buffVis then
			-- if self.db.profile.inRaidOnly then
				-- if UnitInRaid("player") then
					-- self:StartCandyBar("Misdirection")
				-- end
			-- else self:StartCandyBar("Misdirection") end		
		-- end
		
		-- if self.db.profile.cdVis then
			-- if self.db.profile.inRaidOnly then
				-- if UnitInRaid("player") then
					-- self:StartCandyBar("Misdirection Cooldown")
				-- end
			-- else self:StartCandyBar("Misdirection Cooldown") end
		-- end	
		
	-- end
	
end	

function lugMD:RaidOnly()
	if (UnitInRaid("player")) and self.db.profile.inRaidOnly then
		return true 
	elseif (UnitInRaid("player")) and  not self.db.profile.inRaidOnly then
		return false
	elseif not (UnitInRaid("player")) and self.db.profile.inRaidOnly then
		return false
	elseif not (UnitInRaid("player")) and not self.db.profile.inRaidOnly then
		return false
	end
end
	

function lugMD:CHAT_MSG_SPELL_AURA_GONE_SELF()
	if (string.match(arg1, L["Misdirection fades from you."])) then
		self:StopCandyBar("Misdirection")
		self:Send_MDStatus("Stop")
	end
end

function lugMD:CHAT_MSG_ADDON(prefix, message, type, sender)
	-- if received message has prefix from other mod, ignore it
	if prefix ~= "lugMD" then return end
	
	
	--if sender is the player and MD still active, send a raid/party message	
	if sender == playername and message ~= "Stop" then 
		-- self:Print("hello")
		-- self:Print(self.db.profile.tarChanAnnounce)
		if string.len(self.db.profile.tarChanAnnounce) == 1 and self.db.profile.tarChanAnnounce ~="" then
			SendChatMessage(self.db.profile.pre..targetname..self.db.profile.post,"CHANNEL",nil,tonumber(self.db.profile.tarChanAnnounce));
		end
		
		if (UnitInRaid("player") and self.db.profile.raidAnnounce) then
			SendChatMessage(self.db.profile.pre..targetname..self.db.profile.post, "RAID")
		elseif (self.db.profile.partyAnnounce) then
			SendChatMessage(self.db.profile.pre..targetname..self.db.profile.post, "PARTY")
		end
		
		
	end
	
	if sender ~= playername then
		
		-- if the message received is not one telling mod to stop other hunter timer, then create new ones, otherwise stop old one
		if message ~= "Stop" then
			
			-- if the bars are set to visible, create a new bar for the hunter that sent the message, register with correct group and start
			if self.db.profile.buffVis then
				self:RegisterCandyBar(sender.."MD", 30, sender..lmd.db.profile.connector..message, "Interface\\Icons\\Ability_Hunter_Misdirection", "green", "yellow", "red")
				self:SetCandyBarScale(sender.."MD", self.db.profile.buffScale)	
				self:RegisterCandyBarWithGroup(sender.."MD", "Misdirection Buff Group")
				self:StartCandyBar(sender.."MD")
			end
			-- if the bars are set to visible, create a new bar for the hunter that sent the message, register with correct group and start
			if self.db.profile.cdVis then
				self:RegisterCandyBar(sender.."'s Cooldown", 120, sender.."'s Cooldown", nil, "black", "gray", "gray", "green")
				self:SetCandyBarBackgroundColor(sender.."'s Cooldown", "black", 1)
				self:SetCandyBarTextColor(sender.."'s Cooldown", "white", 0.5)
				self:SetCandyBarScale(sender.."'s Cooldown", self.db.profile.cdScale)
				self:RegisterCandyBarWithGroup(sender..L["'s Cooldown"], "Misdirection CD Group")		
				self:StartCandyBar(sender.."'s Cooldown")
			end	
		elseif self.db.profile.buffVis then
			self:StopCandyBar(sender.."MD")
		end
	end
	
	
end


function lugMD:OnClick()	
	
	if IsShiftKeyDown() then
		dewdrop:Open(Minimap)
	else
		self:announceTars()
	end
end


function lugMD:OnEnter()
	if self:IsMinimapAttached() then
		GameTooltip:SetOwner(self.minimapFrame, "ANCHOR_CURSOR")
	else
		GameTooltip:SetOwner(self.frame, "ANCHOR_CURSOR")
	end
	
	GameTooltip:AddLine("lugMD")
	GameTooltip:AddLine("")
	GameTooltip:AddLine(L["Left-click to announce MD targets"])
	GameTooltip:AddLine(L["[Shift]+Left-click to set MD targets"])
	GameTooltip:AddLine(L["Right-click for options"])
	GameTooltip:Show()

	tooltipVisible = true
end

function lugMD:CloseTooltip()
	self:OnLeave()
end

function lugMD:OnLeave()
	if tooltipVisible then
		GameTooltip:Hide()
		tooltipVisible = nil
	end
end

function lugMD:Send_MDStatus(info)
	SendAddonMessage( "lugMD", info, "RAID" );
end

function lugMD:anchors()
	if (self.db.profile.anchorsVis) then
		lugMDBuffAnchorFrame:Show()
		lugMDCooldownAnchorFrame:Show()
	else
		lugMDBuffAnchorFrame:Hide()
		lugMDCooldownAnchorFrame:Hide()
	end
end

function lugMD:Setup()
    -- Cheat for right now & just enable/disable
    if lugMD:IsActive() then
        self:ToggleActive()
        self:ToggleActive()
    end
end
		
-- Announce targets to various channels
function lugMD:announceTars()
	-- self:Print(self.db.profile.tarChanAnnounce)
	-- self:Print(string.len(self.db.profile.tarChanAnnounce))
	
	for i=1,8 do
		if lugMDicons[i].hunter ~= L["None"] and lugMDicons[i].tank ~= L["None"] then 
			
			hlen = string.len(lugMDicons[i].hunter)
			hlen = hlen - 2
			tlen = string.len(lugMDicons[i].tank)
			tlen = tlen - 2
			msg = (lugMDicons[i].name..": "..string.sub(lugMDicons[i].hunter, 11,hlen)..lmd.db.profile.connector..string.sub(lugMDicons[i].tank,11,tlen))
			
			if (UnitInRaid("player") and self.db.profile.tarRaidAnnounce) then
				SendChatMessage(msg, "RAID")
			end
			
			if  self.db.profile.tarChanAnnounce =="" and not self.db.profile.tarRaidAnnounce then
				self:Print("Targets set, but no announce channel!")
			end
			-- self:Print("1"..self.db.profile.tarChanAnnounce.."2")
			if string.len(self.db.profile.tarChanAnnounce) == 1 and self.db.profile.tarChanAnnounce ~="" then
				SendChatMessage(msg,"CHANNEL",nil,tonumber(self.db.profile.tarChanAnnounce));
			end
		end
	end											
end	

function lugMD:IsShowAnchors()
	return self.db.profile.anchorsVis
end

function lugMD:ToggleShowAnchors()
	self.db.profile.anchorsVis = not self.db.profile.anchorsVis	
	self:anchors()
end

function lugMD:IsShowOptions()
	return self.db.profile.optionsVis
end

function lugMD:ToggleShowOptions()
	self.db.profile.optionsVis = not self.db.profile.optionsVis	
	self:options()
end

function lugMD:IsShowBuffs()
	return self.db.profile.buffVis
end

function lugMD:ToggleShowBuffs()
	self.db.profile.buffVis = not self.db.profile.buffVis
end

function lugMD:IsShowCds()
	return self.db.profile.cdVis
end

function lugMD:ToggleShowCds()
	self.db.profile.cdVis = not self.db.profile.cdVis
end

function lugMD:IsGrowup()
	return self.db.profile.growup
end

function lugMD:ToggleGrowup()
	self.db.profile.growup = not self.db.profile.growup
end

function lugMD:IsRaidAnnounce()
	return self.db.profile.raidAnnounce
end

function lugMD:ToggleRaidAnnounce()
	self.db.profile.raidAnnounce = not self.db.profile.raidAnnounce
end

function lugMD:IsPartyAnnounce()
	return self.db.profile.partyAnnounce
end

function lugMD:TogglePartyAnnounce()
	self.db.profile.partyAnnounce = not self.db.profile.partyAnnounce
end

function lugMD:IsTarRaidAnnounce()
	return self.db.profile.tarRaidAnnounce
end

function lugMD:ToggleTarRaidAnnounce()
	self.db.profile.tarRaidAnnounce = not self.db.profile.tarRaidAnnounce
end

function lugMD:IsTarPartyAnnounce()
	return self.db.profile.tarPartyAnnounce
end

function lugMD:ToggleTarPartyAnnounce()
	self.db.profile.tarPartyAnnounce = not self.db.profile.tarPartyAnnounce
end

function lugMD:IsInRaidOnly()
	return self.db.profile.inRaidOnly
end

function lugMD:ToggleInRaidOnly()
	self.db.profile.inRaidOnly = not self.db.profile.inRaidOnly
end

function lugMD:GetBuffScale()
	return self.db.profile.buffScale
end

function lugMD:SetBuffScale(newScale)
	self.db.profile.buffScale = newScale	
end

function lugMD:GetCdScale()
	return self.db.profile.cdScale
end

function lugMD:SetCDScale(newScale)
	self.db.profile.cdScale = newScale	
end

function lugMD:OnDisable()
   
end	